Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLSceneHandler.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLSceneHandler.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLSceneHandler.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLSceneHandler.cc,v 1.45 2006/08/30 11:37:34 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenGLSceneHandler.cc,v 1.51 2007/05/25 15:41:38 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -52,4 +52,5 @@
 #include "G4Transform3D.hh"
 #include "G4Polyline.hh"
+#include "G4Polymarker.hh"
 #include "G4Text.hh"
 #include "G4Circle.hh"
@@ -64,9 +65,12 @@
 #include "G4Scene.hh"
 #include "G4VisExtent.hh"
+#include "G4AttHolder.hh"
 
 G4OpenGLSceneHandler::G4OpenGLSceneHandler (G4VGraphicsSystem& system,
 			      G4int id,
 			      const G4String& name):
-  G4VSceneHandler (system, id, name)
+  G4VSceneHandler (system, id, name),
+  fPickName(0),
+  fProcessingPolymarker(false)
 {}
 
@@ -94,4 +98,39 @@
   0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x55
 };
+
+void G4OpenGLSceneHandler::ClearAndDestroyAtts()
+{
+  std::map<GLuint, G4AttHolder*>::iterator i;
+  for (i = fPickMap.begin(); i != fPickMap.end(); ++i) delete i->second;
+  fPickMap.clear();
+}
+
+void G4OpenGLSceneHandler::PreAddSolid
+(const G4Transform3D& objectTransformation,
+ const G4VisAttributes& visAttribs)
+{
+  G4VSceneHandler::PreAddSolid (objectTransformation, visAttribs);
+}
+
+void G4OpenGLSceneHandler::BeginPrimitives
+(const G4Transform3D& objectTransformation)
+{
+  G4VSceneHandler::BeginPrimitives (objectTransformation);
+}
+
+void G4OpenGLSceneHandler::EndPrimitives ()
+{
+  G4VSceneHandler::EndPrimitives ();
+}
+
+void G4OpenGLSceneHandler::BeginPrimitives2D ()
+{
+  G4VSceneHandler::BeginPrimitives2D ();
+}
+
+void G4OpenGLSceneHandler::EndPrimitives2D ()
+{
+  G4VSceneHandler::EndPrimitives2D ();
+}
 
 const G4Polyhedron* G4OpenGLSceneHandler::CreateSectionPolyhedron ()
@@ -120,4 +159,11 @@
   if (nPoints <= 0) return;
 
+  // Loads G4Atts for picking...
+  if (fpViewer->GetViewParameters().IsPicking()) {
+    G4AttHolder* holder = new G4AttHolder;
+    LoadAtts(line, holder);
+    fPickMap[fPickName] = holder;
+  }
+
   // Note: colour treated in sub-class.
 
@@ -128,5 +174,9 @@
   glDisable (GL_LIGHTING);
 
-  G4double lineWidth = GetLineWidth(line);
+  // Get vis attributes - pick up defaults if none.
+  const G4VisAttributes* pVA =
+    fpViewer -> GetApplicableVisAttributes (line.GetVisAttributes ());
+
+  G4double lineWidth = GetLineWidth(pVA);
   glLineWidth(lineWidth);
 
@@ -142,5 +192,62 @@
 }
 
+void G4OpenGLSceneHandler::AddPrimitive (const G4Polymarker& polymarker)
+{
+  G4int nPoints = polymarker.size ();
+  if (nPoints <= 0) return;
+
+  fProcessingPolymarker = true;
+
+  // Loads G4Atts for picking...
+  if (fpViewer->GetViewParameters().IsPicking()) {
+    G4AttHolder* holder = new G4AttHolder;
+    LoadAtts(polymarker, holder);
+    fPickMap[fPickName] = holder;
+  }
+
+  switch (polymarker.GetMarkerType()) {
+  default:
+  case G4Polymarker::dots:
+    {
+      for (size_t iPoint = 0; iPoint < polymarker.size (); iPoint++) {
+        G4Circle dot (polymarker);
+        dot.SetPosition (polymarker[iPoint]);
+        dot.SetWorldSize  (0.);
+        dot.SetScreenSize (0.1);  // Very small circle.
+        G4OpenGLSceneHandler::AddPrimitive (dot);
+      }
+    }
+    break;
+  case G4Polymarker::circles:
+    {
+      for (size_t iPoint = 0; iPoint < polymarker.size (); iPoint++) {
+        G4Circle circle (polymarker);
+        circle.SetPosition (polymarker[iPoint]);
+        G4OpenGLSceneHandler::AddPrimitive (circle);
+      }
+    }
+    break;
+  case G4Polymarker::squares:
+    {
+      for (size_t iPoint = 0; iPoint < polymarker.size (); iPoint++) {
+        G4Square square (polymarker);
+        square.SetPosition (polymarker[iPoint]);
+        G4OpenGLSceneHandler::AddPrimitive (square);
+      }
+    }
+    break;
+  }
+
+  fProcessingPolymarker = false;
+}
+
 void G4OpenGLSceneHandler::AddPrimitive (const G4Text& text) {
+
+  // Loads G4Atts for picking...
+  if (fpViewer->GetViewParameters().IsPicking()) {
+    G4AttHolder* holder = new G4AttHolder;
+    LoadAtts(text, holder);
+    fPickMap[fPickName] = holder;
+  }
 
   const G4Colour& c = GetTextColour (text);  // Picks up default if none.
@@ -175,5 +282,5 @@
   glDisable (GL_LIGHTING);
   
-  glRasterPos3f(position.x(),position.y(),position.z());
+  glRasterPos3d(position.x(),position.y(),position.z());
   // No action on offset or layout at present.
   glPushAttrib(GL_LIST_BIT);
@@ -185,15 +292,24 @@
 void G4OpenGLSceneHandler::AddPrimitive (const G4Circle& circle) {
   glEnable (GL_POINT_SMOOTH);
-  AddCircleSquare (circle, 24);
+  AddCircleSquare (circle, G4OpenGLBitMapStore::circle);
 }
 
 void G4OpenGLSceneHandler::AddPrimitive (const G4Square& square) {
   glDisable (GL_POINT_SMOOTH);
-  AddCircleSquare (square, 4);
+  AddCircleSquare (square, G4OpenGLBitMapStore::square);
 }
 
 void G4OpenGLSceneHandler::AddCircleSquare
 (const G4VMarker& marker,
- G4int nSides) {
+ G4OpenGLBitMapStore::Shape shape) {
+
+  if (!fProcessingPolymarker) {  // Polymarker has already loaded atts.
+    // Loads G4Atts for picking...
+    if (fpViewer->GetViewParameters().IsPicking()) {
+      G4AttHolder* holder = new G4AttHolder;
+      LoadAtts(marker, holder);
+      fPickMap[fPickName] = holder;
+    }
+  }
 
   // Note: colour treated in sub-class.
@@ -205,172 +321,76 @@
   glDisable (GL_LIGHTING);
   
-  G4double lineWidth = GetLineWidth(marker);
+  // Get vis attributes - pick up defaults if none.
+  const G4VisAttributes* pVA =
+    fpViewer -> GetApplicableVisAttributes (marker.GetVisAttributes ());
+
+  G4double lineWidth = GetLineWidth(pVA);
   glLineWidth(lineWidth);
 
   G4VMarker::FillStyle style = marker.GetFillStyle();
+
+  G4bool filled = false;
+  static G4bool hashedWarned = false;
   
   switch (style) {
   case G4VMarker::noFill: 
     glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
+    filled = false;
     break;
     
   case G4VMarker::hashed:
-    /*
-    G4cout << "Hashed fill style in G4OpenGLSceneHandler."
-	   << "\n  Not implemented.  Using G4VMarker::filled."
-	   << G4endl;
-    */
-    glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
-    glPolygonStipple (fStippleMaskHashed);
-    // See also:
-    //   if (style == G4VMarker::filled || style == G4VMarker::hashed)...
-    // (twice) below.
-    break;
+    if (!hashedWarned) {
+      G4cout << "Hashed fill style in G4OpenGLSceneHandler."
+	     << "\n  Not implemented.  Using G4VMarker::filled."
+	     << G4endl;
+      hashedWarned = true;
+    }
+    // Maybe use
+    //glPolygonStipple (fStippleMaskHashed);
+    // Drop through to filled...
     
   case G4VMarker::filled:
     glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
+    filled = true;
     break;
     
-  default:
-    G4cout << "Unrecognised fill style in G4OpenGLSceneHandler."
-	   << "\n  Using G4VMarker::filled."
-	   << G4endl;
-    glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
-    break;
-    
   }
 
   // A few useful quantities...
   G4Point3D centre = marker.GetPosition();
-  const G4Vector3D& viewpointDirection =
-    fpViewer -> GetViewParameters().GetViewpointDirection();
-  const G4Vector3D& up = fpViewer->GetViewParameters().GetUpVector();
   MarkerSizeType sizeType;
   G4double size = GetMarkerSize(marker, sizeType);
 
-  // Find "size" of marker in world space (but see note below)...
-  G4double worldSize;
+  // Draw...
   if (sizeType == world) {  // Size specified in world coordinates.
-    worldSize = size;
-  }
-  else { // Size specified in screen (window) coordinates.
-
-    // Find window coordinates of centre...
-    GLdouble modelMatrix[16];
-    glGetDoublev (GL_MODELVIEW_MATRIX, modelMatrix);
-    G4double projectionMatrix[16];
-    glGetDoublev (GL_PROJECTION_MATRIX, projectionMatrix);
-    GLint viewport[4];
-    glGetIntegerv(GL_VIEWPORT,viewport);
-    GLdouble winx, winy, winz;
-    gluProject(centre.x(), centre.y(), centre.z(),
-	       modelMatrix, projectionMatrix, viewport,
-	       &winx, &winy, &winz);
-
-    // Determine ratio window:world...
-    const G4Vector3D inScreen = (up.cross(viewpointDirection)).unit();
-    const G4Vector3D p = centre + inScreen;
-    GLdouble winDx, winDy, winDz;
-    gluProject(p.x(), p.y(), p.z(),
-               modelMatrix, projectionMatrix, viewport,
-               &winDx, &winDy, &winDz);
-    G4double winWorldRatio = std::sqrt(std::pow(winx - winDx, 2) +
-				  std::pow(winy - winDy, 2));
-    worldSize = size / winWorldRatio;
-  }
-
-  // Draw...
-  DrawXYPolygon (worldSize, centre, nSides);
-}
-
-/***************************************************
-Note: We have to do it this way round so that when a global
-transformation is applied, such as with /vis/viewer/set/viewpoint,
-the markers follow the world coordinates without having to
-recreate the display lists.  The down side is that the markers
-rotate.  The only way to avoid this is to play with the modelview
-and projection matrices of OpenGL - which I need to think about.
-For future reference, here is the code to draw in window
-coordinates; its down side is that markers do not follow global
-transformations.  Some clever stuff is needed.
-
-  ...
-  // Find window coordinates of centre...
-  GLdouble modelMatrix[16];
-  glGetDoublev (GL_MODELVIEW_MATRIX, modelMatrix);
-  G4double projectionMatrix[16];
-  glGetDoublev (GL_PROJECTION_MATRIX, projectionMatrix);
-  GLint viewport[4];
-  glGetIntegerv(GL_VIEWPORT,viewport);
-  GLdouble winx, winy, winz;
-  gluProject(centre.x(), centre.y(), centre.z(),
-             modelMatrix, projectionMatrix, viewport,
-             &winx, &winy, &winz);
-
-  // Find window size...
-  G4double winSize;
-  if (size) {  // Size specified in world coordinates.
-    // Determine size in window coordinates...
-    (Note: improve this by using an inScreen vector as above.)
-    GLdouble winx1, winy1, winz1;
-    gluProject(centre.x() + size, centre.y() + size, centre.z() + size,
-               modelMatrix, projectionMatrix, viewport,
-               &winx1, &winy1, &winz1);
-    winSize = std::sqrt((std::pow(winx - winx1, 2) +
-                    std::pow(winy - winy1, 2) +
-                    std::pow(winz - winz1, 2)) / 3.);
-  }
-  else {
-    winSize = scale *
-      userSpecified ? marker.GetScreenSize() : def.GetScreenSize();
-  }
-
-  // Prepare to draw in window coordinates...
-  glMatrixMode (GL_PROJECTION);
-  glPushMatrix();
-  glLoadIdentity();
-  gluOrtho2D(GLdouble(viewport[0]),
-             GLdouble(viewport[0] + viewport[2]),
-             GLdouble(viewport[1]),
-             GLdouble(viewport[1] + viewport[3]));
-  glMatrixMode (GL_MODELVIEW);
-  glPushMatrix();
-  glLoadIdentity();
-
-  // Draw in window coordinates...
-  DrawScreenPolygon (winSize, G4Point3D(winx, winy, winz), nSides);
-
-  // Re-instate matrices...
-  glMatrixMode (GL_PROJECTION);
-  glPopMatrix();
-  glMatrixMode (GL_MODELVIEW);
-  glPopMatrix();
-  ...
-}
-
-void G4OpenGLSceneHandler::DrawScreenPolygon
-(G4double size,
+
+    DrawXYPolygon (shape, size, centre, pVA);
+
+  } else { // Size specified in screen (window) coordinates.
+
+    glRasterPos3d(centre.x(),centre.y(),centre.z());
+    const GLubyte* marker =
+      G4OpenGLBitMapStore::GetBitMap(shape, size, filled);
+    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
+    glBitmap(GLsizei(size), GLsizei(size), size/2., size/2., 0., 0., marker);
+  }
+}
+
+void G4OpenGLSceneHandler::DrawXYPolygon
+(G4OpenGLBitMapStore::Shape shape,
+ G4double size,
  const G4Point3D& centre,
- G4int nSides) {
-  glBegin (GL_POLYGON);
-  const G4double dPhi = twopi / nSides;
-  const G4double r = size / 2.;
-  G4double phi;
-  G4int i;
-  for (i = 0, phi = -dPhi / 2.; i < nSides; i++, phi += dPhi) {
-    G4double x, y, z;
-    x = centre.x() + r * std::cos(phi);
-    y = centre.y() + r * std::sin(phi);
-    z = centre.z();
-    glVertex3d (x, y, z);
-  }
-  glEnd ();
-}
-**********************************************/
-
-void G4OpenGLSceneHandler::DrawXYPolygon
-(G4double size,
- const G4Point3D& centre,
- G4int nSides) {
+ const G4VisAttributes* pApplicableVisAtts)
+{
+  G4int nSides;
+  G4double startPhi;
+  if (shape == G4OpenGLBitMapStore::circle) {
+    nSides = GetNoOfSides(pApplicableVisAtts);
+    startPhi = 0.;
+  } else {
+    nSides = 4;
+    startPhi = -pi / 4.;
+  }
+
   const G4Vector3D& viewpointDirection =
     fpViewer -> GetViewParameters().GetViewpointDirection();
@@ -381,6 +401,7 @@
   G4double phi;
   G4int i;
+
   glBegin (GL_POLYGON);
-  for (i = 0, phi = 0.; i < nSides; i++, phi += dPhi) {
+  for (i = 0, phi = startPhi; i < nSides; i++, phi += dPhi) {
     G4Vector3D r = start; r.rotate(phi, viewpointDirection);
     G4Vector3D p = centre + r;
@@ -388,4 +409,9 @@
   }
   glEnd ();
+}
+
+void G4OpenGLSceneHandler::AddPrimitive (const G4Scale& scale)
+{
+  G4VSceneHandler::AddPrimitive(scale);
 }
 
@@ -398,4 +424,11 @@
   if (polyhedron.GetNoFacets() == 0) return;
 
+  // Loads G4Atts for picking...
+  if (fpViewer->GetViewParameters().IsPicking()) {
+    G4AttHolder* holder = new G4AttHolder;
+    LoadAtts(polyhedron, holder);
+    fPickMap[fPickName] = holder;
+  }
+
   // Get vis attributes - pick up defaults if none.
   const G4VisAttributes* pVA =
@@ -410,5 +443,5 @@
   G4OpenGLViewer* pViewer = dynamic_cast<G4OpenGLViewer*>(fpViewer);
   if (pViewer) transparency_enabled = pViewer->transparency_enabled;
-  const G4Colour& c = GetColour (polyhedron);
+  const G4Colour& c = pVA->GetColour();
   GLfloat materialColour [4];
   materialColour [0] = c.GetRed ();
@@ -421,5 +454,5 @@
   }
 
-  G4double lineWidth = GetLineWidth(polyhedron);
+  G4double lineWidth = GetLineWidth(pVA);
   glLineWidth(lineWidth);
 
@@ -681,4 +714,11 @@
 void G4OpenGLSceneHandler::AddPrimitive (const G4NURBS& nurb) {
 
+  // Loads G4Atts for picking...
+  if (fpViewer->GetViewParameters().IsPicking()) {
+    G4AttHolder* holder = new G4AttHolder;
+    LoadAtts(nurb, holder);
+    fPickMap[fPickName] = holder;
+  }
+
   GLUnurbsObj *gl_nurb;
   gl_nurb = gluNewNurbsRenderer ();
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQt.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQt.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQt.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLStoredQt.cc,v 1.11 2007/06/24 12:07:19 $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenGLStoredQt.cc,v 1.1 2007/09/28 14:44:13 lgarnier Exp $
+// GEANT4 tag $Name:  $
 //
 // 
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQtViewer.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQtViewer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredQtViewer.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLStoredQtViewer.cc,v 1.16 2007/06/25 16:38:13 $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenGLStoredQtViewer.cc,v 1.2 2007/11/08 17:00:51 lgarnier Exp $
+// GEANT4 tag $Name:  $
 //
 //
@@ -38,4 +38,7 @@
 
 #include "G4ios.hh"
+
+#include <QtGui/QMouseEvent>
+#include <QtGui/QContextMenuEvent>
 
 G4OpenGLStoredQtViewer::G4OpenGLStoredQtViewer
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredSceneHandler.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredSceneHandler.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredSceneHandler.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLStoredSceneHandler.cc,v 1.31 2006/08/30 11:43:57 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenGLStoredSceneHandler.cc,v 1.34 2007/04/04 16:50:27 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -46,8 +46,12 @@
 #include "G4PhysicalVolumeModel.hh"
 #include "G4VPhysicalVolume.hh"
+#include "G4LogicalVolume.hh"
 #include "G4Polyline.hh"
 #include "G4Polymarker.hh"
+#include "G4Text.hh"
 #include "G4Circle.hh"
 #include "G4Square.hh"
+#include "G4Polyhedron.hh"
+#include "G4AttHolder.hh"
 
 G4OpenGLStoredSceneHandler::G4OpenGLStoredSceneHandler (G4VGraphicsSystem& system,
@@ -56,5 +60,6 @@
 fMemoryForDisplayLists (true),
 fAddPrimitivePreambleNestingDepth (0),
-fTopPODL (0)
+fTopPODL (0),
+fProcessing2D (false)
 {}
 
@@ -69,78 +74,23 @@
   if (fAddPrimitivePreambleNestingDepth > 1) return;
 
+  // Because of our need to control colour of transients (display by
+  // time fading), display lists may only cover a single primitive.
+  // So display list setup is here.
+
+  if (fpViewer->GetViewParameters().IsPicking()) {
+    fPickMap[++fPickName] = 0;
+  }
+
   const G4Colour& c = GetColour (visible);
-
-  if (fMemoryForDisplayLists && fReadyForTransients) {
-
-    TO& to = fTOList.back();  // Transient object information.
-
-    // Get vis attributes - pick up defaults if none.
-    const G4VisAttributes* pVA =
-      fpViewer->GetApplicableVisAttributes(visible.GetVisAttributes());
-
-    // Get time information from vis attributes.
-    to.fStartTime = pVA->GetStartTime();
-    to.fEndTime = pVA->GetEndTime();
-
-    // Keep colour out of (already started) display list so that it
-    // can be applied independently.
-    glEndList();
-    glDeleteLists(fDisplayListId, 1);
-    to.fColour = c;
-    glColor3d (c.GetRed (), c.GetGreen (), c.GetBlue ());
-    glNewList (fDisplayListId, GL_COMPILE_AND_EXECUTE);
-      
-  } else {
-
-    // Make sure colour is set in other cases.
-    glColor3d (c.GetRed (), c.GetGreen (), c.GetBlue ());
-  }
-}
-
-void G4OpenGLStoredSceneHandler::AddPrimitivePostamble()
-{
-  fAddPrimitivePreambleNestingDepth--;
-}
-
-void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Polyline& polyline)
-{
-  AddPrimitivePreamble(polyline);
-  G4OpenGLSceneHandler::AddPrimitive(polyline);
-  AddPrimitivePostamble();
-}
-
-void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Circle& circle)
-{
-  AddPrimitivePreamble(circle);
-  G4OpenGLSceneHandler::AddPrimitive(circle);
-  AddPrimitivePostamble();
-}
-
-void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Square& square)
-{
-  AddPrimitivePreamble(square);
-  G4OpenGLSceneHandler::AddPrimitive(square);
-  AddPrimitivePostamble();
-}
-
-void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Polymarker& polymarker)
-{
-  AddPrimitivePreamble(polymarker);
-  G4OpenGLSceneHandler::AddPrimitive(polymarker);
-  AddPrimitivePostamble();
-}
-
-void G4OpenGLStoredSceneHandler::BeginPrimitives
-(const G4Transform3D& objectTransformation) {
-  
-  G4VSceneHandler::BeginPrimitives (objectTransformation);
 
   if (fMemoryForDisplayLists) {
     fDisplayListId = glGenLists (1);
     if (!fDisplayListId) {  // Could pre-allocate?
-      G4cout << "********************* WARNING! ********************\n"
-	   <<"Unable to allocate any more display lists in OpenGL.\n "
-	   << "      Continuing drawing in IMMEDIATE MODE.\n"
-	   << "***************************************************" << G4endl;
+      G4cout <<
+	"********************* WARNING! ********************"
+	"\nUnable to allocate any more display lists in OpenGL."
+	"\n     Continuing drawing in IMMEDIATE MODE."
+	"\n***************************************************"
+	     << G4endl;
       fMemoryForDisplayLists = false;
     }
@@ -148,25 +98,57 @@
   if (fMemoryForDisplayLists) {
     if (fReadyForTransients) {
-      TO to(fDisplayListId, objectTransformation);
+      TO to(fDisplayListId, *fpObjectTransformation);
+      to.fPickName = fPickName;
+      to.fColour = c;
+      const G4VisAttributes* pVA =
+	fpViewer->GetApplicableVisAttributes(visible.GetVisAttributes());
+      to.fStartTime = pVA->GetStartTime();
+      to.fEndTime = pVA->GetEndTime();
       fTOList.push_back(to);
       glDrawBuffer (GL_FRONT);
       glPushMatrix();
-      G4OpenGLTransform3D oglt (objectTransformation);
+      G4OpenGLTransform3D oglt (*fpObjectTransformation);
       glMultMatrixd (oglt.GetGLMatrix ());
+      glColor3d (c.GetRed (), c.GetGreen (), c.GetBlue ());
       glNewList (fDisplayListId, GL_COMPILE_AND_EXECUTE);
     }
     else {
-      fPOList.push_back(PO(fDisplayListId, objectTransformation));
+      PO po(fDisplayListId, *fpObjectTransformation);
+      po.fPickName = fPickName;
+      fPOList.push_back(po);
       glNewList (fDisplayListId, GL_COMPILE);
+      glColor3d (c.GetRed (), c.GetGreen (), c.GetBlue ());
     }
   } else {
     glDrawBuffer (GL_FRONT);
     glPushMatrix();
-    G4OpenGLTransform3D oglt (objectTransformation);
+    G4OpenGLTransform3D oglt (*fpObjectTransformation);
     glMultMatrixd (oglt.GetGLMatrix ());
-  }
-}
-
-void G4OpenGLStoredSceneHandler::EndPrimitives () {
+    glColor3d (c.GetRed (), c.GetGreen (), c.GetBlue ());
+  }
+
+  if (fProcessing2D) {
+    // Push current 3D world matrices and load identity to define screen
+    // coordinates...
+    glMatrixMode (GL_PROJECTION);
+    glPushMatrix();
+    glLoadIdentity();
+    glOrtho (-1., 1., -1., 1., -G4OPENGL_DBL_MAX, G4OPENGL_DBL_MAX);
+    glMatrixMode (GL_MODELVIEW);
+    glPushMatrix();
+    glLoadIdentity();
+  }
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitivePostamble()
+{
+  if (fProcessing2D) {
+    // Pop current 3D world matrices back again...
+    glMatrixMode (GL_PROJECTION);
+    glPopMatrix();
+    glMatrixMode (GL_MODELVIEW);
+    glPopMatrix();
+  }
+
   if (fMemoryForDisplayLists) {
     glEndList();
@@ -177,61 +159,94 @@
     glDrawBuffer (GL_BACK);
   }
-  G4VSceneHandler::EndPrimitives ();
+  fAddPrimitivePreambleNestingDepth--;
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Polyline& polyline)
+{
+  AddPrimitivePreamble(polyline);
+  G4OpenGLSceneHandler::AddPrimitive(polyline);
+  AddPrimitivePostamble();
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Polymarker& polymarker)
+{
+  AddPrimitivePreamble(polymarker);
+  G4OpenGLSceneHandler::AddPrimitive(polymarker);
+  AddPrimitivePostamble();
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Text& text)
+{
+  // Note: colour is still handled in
+  // G4OpenGLSceneHandler::AddPrimitive(const G4Text&), so it still
+  // gets into the display list
+  AddPrimitivePreamble(text);
+  G4OpenGLSceneHandler::AddPrimitive(text);
+  AddPrimitivePostamble();
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Circle& circle)
+{
+  AddPrimitivePreamble(circle);
+  G4OpenGLSceneHandler::AddPrimitive(circle);
+  AddPrimitivePostamble();
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Square& square)
+{
+  AddPrimitivePreamble(square);
+  G4OpenGLSceneHandler::AddPrimitive(square);
+  AddPrimitivePostamble();
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Scale& scale)
+{
+  // Let base class split into primitives.
+  G4OpenGLSceneHandler::AddPrimitive(scale);
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitive (const G4Polyhedron& polyhedron)
+{
+  // Note: colour is still handled in
+  // G4OpenGLSceneHandler::AddPrimitive(const G4Polyhedron&), so it still
+  // gets into the display list
+  AddPrimitivePreamble(polyhedron);
+  G4OpenGLSceneHandler::AddPrimitive(polyhedron);
+  AddPrimitivePostamble();
+}
+
+void G4OpenGLStoredSceneHandler::AddPrimitive (const G4NURBS& nurbs)
+{
+  // Note: colour is still handled in
+  // G4OpenGLSceneHandler::AddPrimitive(const G4NURBS&), so it still
+  // gets into the display list
+  AddPrimitivePreamble(nurbs);
+  G4OpenGLSceneHandler::AddPrimitive(nurbs);
+  AddPrimitivePostamble();
+}
+
+void G4OpenGLStoredSceneHandler::BeginPrimitives
+(const G4Transform3D& objectTransformation)
+{  
+  G4OpenGLSceneHandler::BeginPrimitives (objectTransformation);
+
+  // Display list setup moved to AddPrimitivePreamble.  See notes there.
+}
+
+void G4OpenGLStoredSceneHandler::EndPrimitives ()
+{
+  G4OpenGLSceneHandler::EndPrimitives ();
 }
 
 void G4OpenGLStoredSceneHandler::BeginPrimitives2D()
 {
-  G4VSceneHandler::BeginPrimitives2D();
-
-  if (fMemoryForDisplayLists) {
-    fDisplayListId = glGenLists (1);
-    if (!fDisplayListId) {  // Could pre-allocate?
-      G4cout << "********************* WARNING! ********************\n"
-	   <<"Unable to allocate any more display lists in OpenGL.\n "
-	   << "      Continuing drawing in IMMEDIATE MODE.\n"
-	   << "***************************************************" << G4endl;
-      fMemoryForDisplayLists = false;
-    }
-  }
-  if (fMemoryForDisplayLists) {
-    if (fReadyForTransients) {
-      fTOList.push_back(TO(fDisplayListId));
-      glDrawBuffer (GL_FRONT);
-      glNewList (fDisplayListId, GL_COMPILE_AND_EXECUTE);
-    }
-    else {
-      fPOList.push_back(PO(fDisplayListId));
-      glNewList (fDisplayListId, GL_COMPILE);
-    }
-  } else {
-    glDrawBuffer (GL_FRONT);
-  }
-  // Push current 3D world matrices and load identity to define screen
-  // coordinates...
-  glMatrixMode (GL_PROJECTION);
-  glPushMatrix();
-  glLoadIdentity();
-  glOrtho (-1., 1., -1., 1., -DBL_MAX, DBL_MAX);
-  glMatrixMode (GL_MODELVIEW);
-  glPushMatrix();
-  glLoadIdentity();
+  G4OpenGLSceneHandler::BeginPrimitives2D();
+  fProcessing2D = true;
 }
 
 void G4OpenGLStoredSceneHandler::EndPrimitives2D ()
 {
-  // Pop current 3D world matrices back again...
-  glMatrixMode (GL_PROJECTION);
-  glPopMatrix();
-  glMatrixMode (GL_MODELVIEW);
-  glPopMatrix();
-
-  if (fMemoryForDisplayLists) {
-    glEndList();
-  }
-  if (fReadyForTransients || !fMemoryForDisplayLists) {
-    glFlush ();
-    glDrawBuffer (GL_BACK);
-  }
-  G4VSceneHandler::EndPrimitives2D ();
+  fProcessing2D = false;
+  G4OpenGLSceneHandler::EndPrimitives2D ();
 }
 
@@ -253,6 +268,5 @@
       "  display List for fTopPODL - try OpenGL Immediated mode."
 	   << G4endl;
-  }
-  else {
+  } else {
     glNewList (fTopPODL, GL_COMPILE_AND_EXECUTE); {
       for (size_t i = 0; i < fPOList.size (); i++) {
@@ -260,4 +274,6 @@
 	G4OpenGLTransform3D oglt (fPOList[i].fTransform);
 	glMultMatrixd (oglt.GetGLMatrix ());
+	if (fpViewer->GetViewParameters().IsPicking())
+	  glLoadName(fPOList[i].fPickName);
 	glCallList (fPOList[i].fDisplayListId);
 	glPopMatrix();
@@ -288,4 +304,5 @@
   fPOList.clear ();
   fSolidMap.clear ();
+  ClearAndDestroyAtts();
 
   // ...and clear transient store...
@@ -375,5 +392,20 @@
 	(fSolidMap.find (pSolid) != fSolidMap.end ())) {
       fDisplayListId = fSolidMap [pSolid];
-      fPOList.push_back(PO(fDisplayListId,*fpObjectTransformation));
+      PO po(fDisplayListId,*fpObjectTransformation);
+      if (fpViewer->GetViewParameters().IsPicking()) {
+	G4AttHolder* holder = new G4AttHolder;
+	// Load G4Atts from G4VisAttributes, if any...
+	const G4VisAttributes* va = pPVModel->GetCurrentLV()->GetVisAttributes();
+	if (va) {
+	  const std::map<G4String,G4AttDef>* vaDefs = va->GetAttDefs();
+	  if (vaDefs) holder->AddAtts(va->CreateAttValues(), vaDefs);
+	}
+	// Load G4Atts from G4PhysicalVolumeModel...
+	const std::map<G4String,G4AttDef>* defs = pPVModel->GetAttDefs();
+	if (defs) holder->AddAtts(pPVModel->CreateCurrentAttValues(), defs);
+	fPickMap[++fPickName] = holder;
+	po.fPickName = fPickName;
+      }
+      fPOList.push_back(po);
     }
     else {
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredViewer.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredViewer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredViewer.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLStoredViewer.cc,v 1.20 2006/10/24 06:23:18 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenGLStoredViewer.cc,v 1.23 2007/04/04 16:50:27 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -88,9 +88,9 @@
       (lastVP.GetNoOfSides ()       != fVP.GetNoOfSides ())       ||
       (lastVP.IsMarkerNotHidden ()  != fVP.IsMarkerNotHidden ())  ||
-      (lastVP.GetBackgroundColour ()!= fVP.GetBackgroundColour ())
-      ) {
-    return true;
-  }
-
+      (lastVP.GetBackgroundColour ()!= fVP.GetBackgroundColour ())||
+      (lastVP.IsPicking ()          != fVP.IsPicking ())
+      )
+    return true;
+  
   if (lastVP.IsDensityCulling () &&
       (lastVP.GetVisibleDensity () != fVP.GetVisibleDensity ()))
@@ -142,16 +142,17 @@
     }
 
-    if (fG4OpenGLStoredSceneHandler.fTopPODL)
+    if (fG4OpenGLStoredSceneHandler.fTopPODL) 
       glCallList (fG4OpenGLStoredSceneHandler.fTopPODL);
-    size_t tmp_size = fG4OpenGLStoredSceneHandler.fTOList.size();
-    G4double bsf = 1.;  // Brightness scaling factor.
-    for (size_t i = 0; i < tmp_size; ++i) {
+
+    for (size_t i = 0; i < fG4OpenGLStoredSceneHandler.fTOList.size(); ++i) {
       G4OpenGLStoredSceneHandler::TO& to =
 	fG4OpenGLStoredSceneHandler.fTOList[i];
-      if ((!(to.fEndTime < fStartTime ))&& (!(to.fStartTime > fEndTime))) {
+      if (to.fEndTime >= fStartTime && to.fStartTime <= fEndTime) {
 	glPushMatrix();
 	G4OpenGLTransform3D oglt (to.fTransform);
 	glMultMatrixd (oglt.GetGLMatrix ());
+	if (fVP.IsPicking()) glLoadName(to.fPickName);
 	G4Colour& c = to.fColour;
+	G4double bsf = 1.;  // Brightness scaling factor.
 	if (fFadeFactor > 0. && to.fEndTime < fEndTime)
 	  bsf = 1. - fFadeFactor *
@@ -167,9 +168,9 @@
 
   // Display time at "head" of time range, which is fEndTime...
-  if (fDisplayHeadTime && fEndTime < DBL_MAX) {
+  if (fDisplayHeadTime && fEndTime < G4OPENGL_DBL_MAX) {
     glMatrixMode (GL_PROJECTION);
     glPushMatrix();
     glLoadIdentity();
-    glOrtho (-1., 1., -1., 1., -DBL_MAX, DBL_MAX);
+    glOrtho (-1., 1., -1., 1., -G4OPENGL_DBL_MAX, G4OPENGL_DBL_MAX);
     glMatrixMode (GL_MODELVIEW);
     glPushMatrix();
@@ -183,5 +184,6 @@
 			      fDisplayHeadTimeBlue));
     headTimeText.SetVisAttributes(&visAtts);
-    fG4OpenGLStoredSceneHandler.AddPrimitive(headTimeText);
+    static_cast<G4OpenGLSceneHandler&>(fSceneHandler).
+      G4OpenGLSceneHandler::AddPrimitive(headTimeText);
     glMatrixMode (GL_PROJECTION);
     glPopMatrix();
@@ -191,5 +193,5 @@
 
   // Display light front...
-  if (fDisplayLightFront && fEndTime < DBL_MAX) {
+  if (fDisplayLightFront && fEndTime < G4OPENGL_DBL_MAX) {
     G4double lightFrontRadius = (fEndTime - fDisplayLightFrontT) * c_light;
     if (lightFrontRadius > 0.) {
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredWin32.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredWin32.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredWin32.cc	(revision 593)
@@ -26,5 +26,5 @@
 //
 // $Id: G4OpenGLStoredWin32.cc,v 1.14 2006/08/14 12:07:19 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
Index: trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredWin32Viewer.cc
===================================================================
--- trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredWin32Viewer.cc	(revision 592)
+++ trunk/geant4/visualization/OpenGL/src/G4OpenGLStoredWin32Viewer.cc	(revision 593)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4OpenGLStoredWin32Viewer.cc,v 1.18 2006/09/04 12:07:59 allison Exp $
-// GEANT4 tag $Name: geant4-08-02-patch-01 $
+// $Id: G4OpenGLStoredWin32Viewer.cc,v 1.19 2007/04/04 16:50:27 allison Exp $
+// GEANT4 tag $Name: geant4-09-00-ref-01 $
 //
 // 
@@ -123,5 +123,7 @@
 
   glFlush ();
-  ::SwapBuffers(fHDC);
+  GLint renderMode;
+  glGetIntegerv(GL_RENDER_MODE, &renderMode);
+  if (renderMode == GL_RENDER) ::SwapBuffers(fHDC);
 
   // Empty the Windows message queue :
